* Version 1.0
LPARAMETERS lcFileName,cCur,lcFFields,lnStartRows,lnTable
* Parametres
* lcFileName		nom de xlsx
* cCur				nom de la table / curseur ; optionnel ; dfaut ALIAS()
* lcFFields			liste des champs ; optionnel ; dfaut tous les champs
* lnStartRows		a partir range (les premiers lnStartRows - 1 lignes sont passes) ; optionnel ; dfaut 1 (tous les champs lignes)
* lnTable			table# ; optionnel ; dfaut 1
DECLARE Sleep IN WIN32API INTEGER 
#DEFINE ERRMESS1 "Rien a ajouter"
#DEFINE ERRMESS2 "S'il vous plat ouvrir la table / curseur"
#DEFINE ERRMESS3 "Tableau introuvable"
#DEFINE ERRMESS4 "Erreur d'ouverture"

LOCAL lcDir,lSetTalk,lnFFields,laFFields[1],lnColsNoAll,laFieldsAll[1],lnColsNo,laFields[1],lnCurCol,llMemos,lnSelect
lnSelect = SELECT(0)

IF PCOUNT() < 1 
	MESSAGEBOX(ERRMESS1,16,"Error")
	RETURN
ELSE
	IF VARTYPE(m.lcFileName) $ "CV"
		lcFileName = FORCEEXT(m.lcFileName,"docx")
		IF !FILE(m.lcFileName)
			MESSAGEBOX(ERRMESS1,16,"Error")
			RETURN
		ENDIF
	ELSE
		MESSAGEBOX(ERRMESS1,16,"Error")
		RETURN
	ENDIF
ENDIF
IF PCOUNT() >= 2 
	IF VARTYPE(m.cCur) $ "CV"
		IF USED(m.cCur)
			SELECT (m.cCur)
		ELSE
			MESSAGEBOX(ERRMESS2,16,"Error")
			RETURN
		ENDIF
	ELSE
		cCur = ALIAS()
	ENDIF
ELSE
	cCur = ALIAS()
ENDIF
IF PCOUNT()<3
	lcFFields = ""
ELSE
	IF VARTYPE(m.lcFFields) <> "C"
		lcFFields = ""
	ELSE
		lnFFields = ALINES(laFFields,m.lcFFields,1+4,",")
	ENDIF
ENDIF
IF PCOUNT() < 4
	lnStartRows = 1
ELSE
	IF VARTYPE(m.lnStartRows) <> "N"
		lnStartRows = 1
	ENDIF
ENDIF
IF PCOUNT()<5
	lnTable = 1
ELSE
	IF VARTYPE(m.lnTable) <> "N"
		lnTable = 1
	ENDIF
ENDIF

lSetTalk = SET("Talk")
SET TALK OFF 
lnColsNoAll = AFIELDS(m.laFieldsAll,m.cCur)
STORE .F. TO llMemos
lnColsNo = 0
FOR lnCurCol = 1 TO m.lnColsNoAll
	IF m.laFieldsAll[m.lnCurCol,2] $ "NFYBIDTLCVM"
		IF !EMPTY(m.lcFFields)
			IF ASCAN(m.laFFields,laFieldsAll[m.lnCurCol,1],1,-1,-1,1+2+4)=0
				LOOP
			ENDIF
		ENDIF
		lnColsNo = m.lnColsNo + 1
		DIMENSION laFields[m.lnColsNo,3]
		laFields[m.lnColsNo,1] = laFieldsAll[m.lnCurCol,1]
		laFields[m.lnColsNo,2] = laFieldsAll[m.lnCurCol,2]
		laFields[m.lnColsNo,3] = m.lnCurCol
		IF laFields[m.lnColsNo,2] == "M"
			llMemos = .T.
		ENDIF
	ELSE
		LOOP
	ENDIF
NEXT

lcDir = extract(m.lcFileName)

= get_cells(ADDBS(m.lcDir) + "document.xml",m.cCur,@laFields,m.lnStartRows,m.lnTable)
cleanup(m.lcDir)
SET TALK &lSetTalk
SELECT (m.lnSelect)
RETURN .T.

*********************
* Extract xml files *
*********************
FUNCTION extract
	LPARAMETERS lcFileName
	LOCAL lcDir,lcZip,oShell,ofile,loErr as Exception,lcSetSaf,lni,lnFF
	lcDir = ADDBS(JUSTPATH(FULLPATH(m.lcFileName))) + SYS(2015)
	lcZip = FORCEEXT(m.lcDir,'.zip')
	COPY FILE (m.lcFileName) TO (m.lcZip)
	MD (m.lcDir)
	oShell = CREATEOBJECT("shell.application")
	TRY
		FOR lni = 0 TO m.oShell.NameSpace(ADDBS(m.lcZip)+'word').items.count - 1
			ofile = m.oShell.NameSpace(ADDBS(m.lcZip)+'word').items.item(m.lni)
			IF m.ofile.name == 'document.xml'
				oShell.NameSpace( m.lcDir).copyhere( m.ofile)
				lnFF = FOPEN(ADDBS(lcDir) + m.ofile.name)
				DO WHILE m.lnFF < 0
					sleep(50)
					lnFF = FOPEN(m.ofile.name)
				ENDDO
				FCLOSE(m.lnFF)
			ENDIF
		ENDFOR
	CATCH TO loErr
	ENDTRY
RETURN lcDir
	

*****************
* Read document *
*****************
FUNCTION get_cells
	LPARAMETERS lcStr,cCur,laField,lnStartRows,lnTable
	LOCAL lcSetDec,lnCurRow,lnField,laFieldGat[1],lni,lcWholeDoc,lnNoOfTables,lcWholeTable,lcWholeRow,lcCell,lcVal
	lnField = ALEN(laField,1)
	lcSetDec = SET("Decimals")
	SET DECIMALS TO 10

	lcWholeDoc = FILETOSTR(m.lcStr)
	lnNoOfTables = OCCURS("<w:tbl>",m.lcWholeDoc)
	IF m.lnNoOfTables < m.lnTable
		MESSAGEBOX(ERRMESS3,16,"Error")
		RETURN ''
	ENDIF
	lcWholeTable = STREXTRACT(m.lcWholeDoc,"<w:tbl>","</w:tbl>",m.lnTable)
	lnCurRow = m.lnStartRows
	lcWholeRow = STREXTRACT(m.lcWholeTable,"<w:tr","</w:tr>",m.lnCurRow)
	DO WHILE !EMPTY(m.lcWholeRow)
		lcWholeRow = STREXTRACT(m.lcWholeTable,"<w:tr ","</w:tr>",m.lnCurRow)
		IF EMPTY(m.lcWholeRow)
			EXIT
		ENDIF
		SELECT (m.cCur)
		APPEND BLANK
		SCATTER MEMO TO laFieldGat
		FOR lni = 1 TO lnField
			lcCell = STREXTRACT(m.lcWholeRow,[<w:tc>],[</w:tc>],m.lni)
			lcVal = STREXTRACT(m.lcCell,[<w:t>],[</w:t>])
			IF EMPTY(m.lcVal)
				LOOP
			ENDIF
			IF laField[m.lni,2] $ "CVM"
				laFieldGat[laField[m.lni,3]] = htmspec(m.lcVal)
			ELSE
				IF laField[m.lni,2] $ "NFBYI"
					laFieldGat[laField[m.lni,3]] = VAL(m.lcVal)
				ELSE
					IF laField[m.lni,2] $ "D"
						laFieldGat[laField[m.lni,3]] = CTOD(m.lcVal)
					ELSE
						IF laField[m.lni,2] $ "T"
							laFieldGat[laField[m.lni,3]] = CTOT(m.lcVal)
						ELSE
							IF laField[m.lni,2] $ "L"
								laFieldGat[laField[m.lni,3]] = m.lcVal == "true"
							ENDIF
						ENDIF
					ENDIF
				ENDIF
			ENDIF
		NEXT
		SELECT (m.cCur)
		GATHER FROM laFieldGat MEMO
		lnCurRow = m.lnCurRow + 1
	ENDDO
	SET DECIMALS TO &lcSetDec 
RETURN m.cCur

**********************
* Special characters *
**********************
FUNCTION htmspec
	LPARAMETERS cStr
	LOCAL lni,lcStrF,lcChar,lnChar
	lcStrF = m.cStr
	IF AT('&gt;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&gt;','>')
	ENDIF
	IF AT('&lt;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&lt;','<')
	ENDIF
	IF AT('&quot;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&quot;','"')
	ENDIF
	IF AT("&apos;",m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&apos;',"'")
	ENDIF
	IF AT([&#],m.lcStrF)>0
		FOR lnChar = 0 TO 255
			lcChar = [&#]+STR(m.lnChar,3)+[;]
			IF AT(m.lcChar,m.lcStrF)>0
				lcStrF = STRTRAN(m.lcStrF,m.lcChar,CHR(lnChar))
			ENDIF
		NEXT
	ENDIF
	IF AT([&#x],m.lcStrF)>0
		FOR lnChar = 0 TO 255
			lcChar = [&#x]+RIGHT(TRANSFORM(m.lnChar,"@0"),2)+[;]
			IF AT(m.lcChar,m.lcStrF)>0
				lcStrF = STRTRAN(m.lcStrF,m.lcChar,CHR(lnChar))
			ENDIF
		NEXT
	ENDIF
	IF AT('&amp;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&amp;',CHR(38))
	ENDIF
	RETURN m.lcStrF
ENDFUNC

*****************
* Cleanup
******************
FUNCTION cleanup
	LPARAMETERS lcDir
	LOCAL lcZip,lcSetSaf
	lcZip = FORCEEXT(m.lcDir,'zip')
	lcSetSaf = SET("Safety")
	SET SAFETY OFF
	TRY 
		ERASE (ADDBS(m.lcDir)+'*.*')
		RD (m.lcDir)
	CATCH TO m.loErr
	ENDTRY

	ERASE (m.lcZip)
	SET SAFETY &lcSetSaf
RETURN .T.
